new file mode 100644
@@ -0,0 +1,55 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2021 Oracle. All Rights Reserved.
+
+# Boilerplate fstests functionality
+
+# Standard cleanup function. Individual tests can override this.
+_cleanup()
+{
+ cd /
+ rm -r -f $tmp.*
+}
+
+# Install the supplied cleanup code as a signal handler for HUP, INT, QUIT,
+# TERM, or when the test exits. Extra signals can be specified as subsequent
+# parameters.
+_register_cleanup()
+{
+ local cleanup="$1"
+ shift
+
+ test -n "$cleanup" && cleanup="${cleanup}; "
+ trap "${cleanup}exit \$status" EXIT HUP INT QUIT TERM $*
+}
+
+# Prepare to run a fstest by initializing the required global variables to
+# their defaults, sourcing common functions, registering a cleanup function,
+# and removing the $seqres.full file.
+#
+# The list of group memberships for this test (e.g. auto quick rw) must be
+# passed as arguments to this helper. It is not necessary to name this test
+# explicitly as a member of the 'all' group.
+_begin_fstest()
+{
+ if [ -n "$seq" ]; then
+ echo "_begin_fstest can only be called once!"
+ exit 1
+ fi
+
+ seq=`basename $0`
+ seqres=$RESULT_DIR/$seq
+ echo "QA output created by $seq"
+
+ here=`pwd`
+ tmp=/tmp/$$
+ status=1 # failure is the default!
+
+ _register_cleanup _cleanup
+
+ . ./common/rc
+
+ # remove previous $seqres.full before test
+ rm -f $seqres.full
+
+}
@@ -153,27 +153,18 @@ cat <<End-of-File >$tdir/$id
#
# what am I here for?
#
-seq=\`basename \$0\`
-seqres=\$RESULT_DIR/\$seq
-echo "QA output created by \$seq"
-
-here=\`pwd\`
-tmp=/tmp/\$\$
-status=1 # failure is the default!
-trap "_cleanup; exit \\\$status" 0 1 2 3 15
-
-_cleanup()
-{
- cd /
- rm -f \$tmp.*
-}
-
-# get standard environment, filters and checks
-. ./common/rc
-. ./common/filter
-
-# remove previous \$seqres.full before test
-rm -f \$seqres.full
+. ./common/preamble
+_begin_fstest group list here
+
+# Override the default cleanup function.
+# _cleanup()
+# {
+# cd /
+# rm -r -f \$tmp.*
+# }
+
+# Import common functions.
+# . ./common/filter
# real QA test starts here